/* example.cpp
 * 
 * An example of libRNGnet using
 *
 */
 

#include "stdafx.h"
#include <iostream> 
#include "libRNGnet.h" 

typedef std::tr1::mt19937 Myeng; 
// typedef shifted_exponential<double> Mydist;  
// typedef truncated_exponential<double> Mydist; 
typedef SYN_exponential<double> Mydist; 
   
   
int main()
{
	Myeng eng; 
    Mydist dist(0.5, 3.0); 

	Mydist::input_type engval = eng(); 
    Mydist::result_type distval = dist(eng);

 	std::cout << "lambda == " << dist.lambda() << std::endl;
    std::cout << "timeout == " << dist.timeout() << std::endl << std::endl; 

    std::cout << "mean == " << dist.mean() << std::endl; 
    
	double mean = 0.0;
    for (int i = 0; i < 100000; i++){mean +=dist(eng);}
    std::cout << "expected mean == " << mean/100000.0 << std::endl << std::endl; 
    
    dist.reset(); 
    std::cout << "a random value == " << dist(eng) << std::endl; 
    std::cout << "a random value == " << dist(eng) << std::endl; 
    std::cout << "a random value == " << dist(eng) << std::endl; 
    	
    return 0;
}

